## smc-tools 1.2.0

=== Makefile ===
#
# SMC Tools - Shared Memory Communication Tools
#
# Copyright IBM Corp. 2016, 2018
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# which accompanies this distribution, and is available at
# http://www.eclipse.org/legal/epl-v10.html
#

SMC_TOOLS_RELEASE = 1.2.0
VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)

ARCHTYPE = $(shell uname -m)
ARCH := $(shell getconf LONG_BIT)
DISTRO := $(shell lsb_release -si 2>/dev/null)

ifneq ("${V}","1")
        MAKEFLAGS += --quiet
        cmd = echo $1$2;
else
        cmd =
endif
CCC               = $(call cmd,"  CC      ",$@)${CC}
LINK              = $(call cmd,"  LINK    ",$@)${CC}
GEN               = $(call cmd,"  GEN     ",$@)sed
DESTDIR          ?=
PREFIX            = /usr
BINDIR		  = ${PREFIX}/bin
MANDIR		  = ${PREFIX}/share/man
OWNER		  = $(shell id -un)
GROUP		  = $(shell id -gn)
INSTALL_FLAGS_BIN = -g $(GROUP) -o $(OWNER) -m755
INSTALL_FLAGS_MAN = -g $(GROUP) -o $(OWNER) -m644
INSTALL_FLAGS_LIB = -g $(GROUP) -o $(OWNER) -m4755

STUFF_32BIT	  = 0
#
# Check that 31/32-bit build tools are available.
#
ifeq ($(ARCH),64)
ifeq ($(DISTRO),Ubuntu)
LIBDIR		= ${PREFIX}/lib/s390x-linux-gnu
else
LIBDIR		= ${PREFIX}/lib64
endif
ifneq ("$(wildcard ${PREFIX}/include/gnu/stubs-32.h)","")
STUFF_32BIT = 1
LIBDIR32	= ${PREFIX}/lib
endif
else
ifeq ($(DISTRO),Ubuntu)
LIBDIR		= ${PREFIX}/lib/s390-linux-gnu
else
LIBDIR		= ${PREFIX}/lib
endif
endif

all: libsmc-preload.so libsmc-preload32.so smcss smc_pnet

CFLAGS ?= -Wall -O3 -g
ALL_CFLAGS = -DSMC_TOOLS_RELEASE=$(SMC_TOOLS_RELEASE) $(CFLAGS)

ifeq ($(ARCHTYPE),s390x)
	MACHINE_OPT32="-m31"
else
	MACHINE_OPT32="-m32"
endif

%: %.in
	$(GEN) -e "s#x.x.x#$(SMC_TOOLS_RELEASE)#g" < $< > $@

smc-preload.o: smc-preload.c
	${CCC} ${CFLAGS} -fPIC -c smc-preload.c

libsmc-preload.so: smc-preload.o
	${LINK} ${LDFLAGS} -shared smc-preload.o -ldl -Wl,-z,defs,-soname,$@.$(VER_MAJOR) -o $@
	chmod u+s $@

libsmc-preload32.so: smc-preload.c
ifeq ($(ARCH),64)
ifeq ($(STUFF_32BIT),1)
	${CCC} ${CFLAGS} -fPIC -c ${MACHINE_OPT32} $< -o smc-preload32.o
	${LINK} ${LDFLAGS} -shared smc-preload32.o ${MACHINE_OPT32} -ldl -Wl,-soname,$@.$(VER_MAJOR) -o $@
	chmod u+s $@
else
	$(warning "Warning: Skipping 31/32-bit library build because 31/32-bit build tools")
	$(warning "         are unavailable. SMC will not support 31/32 bit applications")
	$(warning "         unless the glibc devel package for the appropriate addressing")
	$(warning "         mode is installed and the preload libraries are rebuilt.")
endif
endif

ifneq ($(shell sh -c 'command -v pkg-config'),)
SMC_PNET_CFLAGS = $(shell pkg-config --silence-errors --cflags libnl-genl-3.0)
SMC_PNET_LFLAGS = $(shell pkg-config --silence-errors --libs libnl-genl-3.0)
else
SMC_PNET_CFLAGS = -I /usr/include/libnl3
SMC_PNET_LFLAGS = -lnl-genl-3 -lnl-3
endif

smc_pnet: smc_pnet.c smc.h smctools_common.h
	@if [ ! -e /usr/include/libnl3/netlink/netlink.h ]; then \
		printf "**************************************************************\n" >&2; \
		printf "* Missing build requirement for: %-45s\n" $@ >&2; \
		printf "* Install package..............: %-45s\n" "devel package for libnl3" >&2; \
		printf "* Install package..............: %-45s\n" "devel package for libnl3-genl" >&2; \
		printf "* NOTE: Package names might differ by platform\n" >&2; \
		printf "**************************************************************\n" >&2; \
		exit 1; \
	fi
	${CCC} ${ALL_CFLAGS} ${SMC_PNET_CFLAGS} ${LDFLAGS} -o $@ $< ${SMC_PNET_LFLAGS}

smcss: smcss.c smc_diag.h smctools_common.h
	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $< -o $@

install: all
	echo "  INSTALL"
	install -d -m755 $(DESTDIR)$(LIBDIR) $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man7 $(DESTDIR)$(MANDIR)/man8
	install $(INSTALL_FLAGS_LIB) libsmc-preload.so $(DESTDIR)$(LIBDIR)
ifeq ($(STUFF_32BIT),1)
	install -d -m755 $(DESTDIR)$(LIBDIR32)
	install $(INSTALL_FLAGS_LIB) libsmc-preload32.so $(DESTDIR)$(LIBDIR32)/libsmc-preload.so
endif
	install $(INSTALL_FLAGS_BIN) smc_run $(DESTDIR)$(BINDIR)
	install $(INSTALL_FLAGS_BIN) smcss $(DESTDIR)$(BINDIR)
	install $(INSTALL_FLAGS_BIN) smc_pnet $(DESTDIR)$(BINDIR)
	install $(INSTALL_FLAGS_BIN) smc_dbg $(DESTDIR)$(BINDIR)
ifeq ($(shell uname -m | cut -c1-4),s390)
	install $(INSTALL_FLAGS_BIN) smc_rnics $(DESTDIR)$(BINDIR)
endif
	install $(INSTALL_FLAGS_MAN) af_smc.7 $(DESTDIR)$(MANDIR)/man7
	install $(INSTALL_FLAGS_MAN) smc_run.8 $(DESTDIR)$(MANDIR)/man8
	install $(INSTALL_FLAGS_MAN) smc_rnics.8 $(DESTDIR)$(MANDIR)/man8
	install $(INSTALL_FLAGS_MAN) smc_pnet.8 $(DESTDIR)$(MANDIR)/man8
	install $(INSTALL_FLAGS_MAN) smcss.8 $(DESTDIR)$(MANDIR)/man8

clean:
	echo "  CLEAN"
	rm -f *.o *.so smcss smc_pnet

## smc-tools 1.1.0

=== debian/changelog ===
smc-tools (1.1.0-0ubuntu1) cosmic; urgency=medium

  * Initial release LP: #1689782

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 04 Sep 2018 08:24:34 +0100

=== debian/control ===
Source: smc-tools
Section: net
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper (>= 11), libnl-genl-3-dev
Standards-Version: 4.2.1
Homepage: https://www.ibm.com/developerworks/linux/linux390/smc-tools.html

Package: smc-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: enables SMC socket usage on Linux
 Shared Memory Communication Tools (smc-tools) enables usage of SMC
 sockets in Linux. This package includes ld-preloadable library and
 utilities to facilitate wrap and use SMC sockets, where TCP ones are
 expected.

## smc-tools 1.2.0

=== debian/changelog ===
smc-tools (1.2.0-0ubuntu1) disco; urgency=medium

  * New upstream release LP: #1815425
  * Drop multiarch patch, applied upstream. Thanks!

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 21 Feb 2019 11:14:06 +0100

## smc-tools 1.2.1

=== debian/changelog ===
smc-tools (1.2.1-0ubuntu1) eoan; urgency=medium

  * New upstream release LP: #1826193
  * Correct multiarch libdir location better

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 30 Apr 2019 13:17:31 +0100

## smc-tools 1.2.2

=== debian/changelog ===
smc-tools (1.2.2-0ubuntu1) focal; urgency=medium

  * New upstream release LP: #1852721

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 10 Feb 2020 01:42:48 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: optional
 Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
-Build-Depends: debhelper (>= 11), libnl-genl-3-dev
+Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion
 Standards-Version: 4.2.1
 Homepage: https://www.ibm.com/developerworks/linux/linux390/smc-tools.html

## smc-tools 1.3.0

=== debian/changelog ===
smc-tools (1.3.0-0ubuntu2) groovy; urgency=medium

  * Add build-depends on pkg-config, such that build-depends on
    bash-completion is actually detected and bash completion gets
    installed. LP: #1891642

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 26 Aug 2020 20:07:47 +0100

smc-tools (1.3.0-0ubuntu1) groovy; urgency=medium

  * New upstream release. LP: #1884508

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 12 Aug 2020 14:16:11 +0100

## smc-tools 1.5.0

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.2.0
+SMC_TOOLS_RELEASE = 1.5.0
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)
@@ -29,6 +29,7 @@
 PREFIX            = /usr
 BINDIR		  = ${PREFIX}/bin
 MANDIR		  = ${PREFIX}/share/man
+BASH_AUTODIR	  = $(shell pkg-config --variable=completionsdir bash-completion 2>/dev/null)
 OWNER		  = $(shell id -un)
 GROUP		  = $(shell id -gn)
 INSTALL_FLAGS_BIN = -g $(GROUP) -o $(OWNER) -m755
@@ -41,7 +42,7 @@
 #
 ifeq ($(ARCH),64)
 ifeq ($(DISTRO),Ubuntu)
-LIBDIR		= ${PREFIX}/lib/s390x-linux-gnu
+LIBDIR		= ${PREFIX}/lib/${ARCHTYPE}-linux-gnu
 else
 LIBDIR		= ${PREFIX}/lib64
 endif
@@ -57,19 +58,31 @@
 endif
 endif
 
-all: libsmc-preload.so libsmc-preload32.so smcss smc_pnet
+all: libsmc-preload.so libsmc-preload32.so smcd smcr smcss smc_pnet
 
 CFLAGS ?= -Wall -O3 -g
 ALL_CFLAGS = -DSMC_TOOLS_RELEASE=$(SMC_TOOLS_RELEASE) $(CFLAGS)
 
+ifneq ($(shell sh -c 'command -v pkg-config'),)
+SMC_PNET_CFLAGS = $(shell pkg-config --silence-errors --cflags libnl-genl-3.0)
+SMC_PNET_LFLAGS = $(shell pkg-config --silence-errors --libs libnl-genl-3.0)
+else
+SMC_PNET_CFLAGS = -I /usr/include/libnl3
+SMC_PNET_LFLAGS = -lnl-genl-3 -lnl-3
+endif
+CFLAGS += ${SMC_PNET_CFLAGS}
+
 ifeq ($(ARCHTYPE),s390x)
 	MACHINE_OPT32="-m31"
 else
 	MACHINE_OPT32="-m32"
 endif
 
-%: %.in
-	$(GEN) -e "s#x.x.x#$(SMC_TOOLS_RELEASE)#g" < $< > $@
+util.o: util.c  util.h
+	${CCC} ${CFLAGS} -c util.c
+
+libnetlink.o: libnetlink.c  libnetlink.h
+	${CCC} ${CFLAGS} ${LDFLAGS} -c libnetlink.c
 
 smc-preload.o: smc-preload.c
 	${CCC} ${CFLAGS} -fPIC -c smc-preload.c
@@ -92,50 +105,103 @@
 endif
 endif
 
-ifneq ($(shell sh -c 'command -v pkg-config'),)
-SMC_PNET_CFLAGS = $(shell pkg-config --silence-errors --cflags libnl-genl-3.0)
-SMC_PNET_LFLAGS = $(shell pkg-config --silence-errors --libs libnl-genl-3.0)
-else
-SMC_PNET_CFLAGS = -I /usr/include/libnl3
-SMC_PNET_LFLAGS = -lnl-genl-3 -lnl-3
-endif
-
-smc_pnet: smc_pnet.c smc.h smctools_common.h
+
+%d.o: %.c
+	${CCC} ${ALL_CFLAGS} -DSMCD -c $< -o $@
+
+%r.o: %.c
+	${CCC} ${ALL_CFLAGS} -DSMCR -c $< -o $@
+
+%.o: %.c
+	${CCC} ${ALL_CFLAGS} -c $< -o $@
+
+smc: smc.o dev.o linkgroup.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
+
+smcd: smcd.o infod.o devd.o linkgroupd.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
+
+smcr: smcr.o infor.o devr.o linkgroupr.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
+
+smc_pnet: smc_pnet.c smctools_common.h
 	@if [ ! -e /usr/include/libnl3/netlink/netlink.h ]; then \
 		printf "**************************************************************\n" >&2; \
 		printf "* Missing build requirement for: %-45s\n" $@ >&2; \
 		printf "* Install package..............: %-45s\n" "devel package for libnl3" >&2; \
 		printf "* Install package..............: %-45s\n" "devel package for libnl3-genl" >&2; \
 		printf "* NOTE: Package names might differ by platform\n" >&2; \
+		printf "*       On Ubuntu try libnl-3-dev and libnl-genl-3-dev\n" >&2; \
 		printf "**************************************************************\n" >&2; \
 		exit 1; \
 	fi
 	${CCC} ${ALL_CFLAGS} ${SMC_PNET_CFLAGS} ${LDFLAGS} -o $@ $< ${SMC_PNET_LFLAGS}
 
-smcss: smcss.c smc_diag.h smctools_common.h
-	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $< -o $@
+smcss: smcss.o libnetlink.o
+	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
+#smcss: smcss.c smctools_common.h libnetlink.h
+#	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $< -o $@
 
 install: all
 	echo "  INSTALL"
-	install -d -m755 $(DESTDIR)$(LIBDIR) $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man7 $(DESTDIR)$(MANDIR)/man8
+	install -d -m755 $(DESTDIR)$(LIBDIR) $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man7 \
+	                 $(DESTDIR)$(BASH_AUTODIR) $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_LIB) libsmc-preload.so $(DESTDIR)$(LIBDIR)
-ifeq ($(STUFF_32BIT),1)
-	install -d -m755 $(DESTDIR)$(LIBDIR32)
-	install $(INSTALL_FLAGS_LIB) libsmc-preload32.so $(DESTDIR)$(LIBDIR32)/libsmc-preload.so
-endif
+#ifeq ($(STUFF_32BIT),1)
+#	install -d -m755 $(DESTDIR)$(LIBDIR32)
+#	install $(INSTALL_FLAGS_LIB) libsmc-preload32.so $(DESTDIR)$(LIBDIR32)/libsmc-preload.so
+#endif
 	install $(INSTALL_FLAGS_BIN) smc_run $(DESTDIR)$(BINDIR)
+	install $(INSTALL_FLAGS_BIN) smcd $(DESTDIR)$(BINDIR)
+	install $(INSTALL_FLAGS_BIN) smcr $(DESTDIR)$(BINDIR)
 	install $(INSTALL_FLAGS_BIN) smcss $(DESTDIR)$(BINDIR)
 	install $(INSTALL_FLAGS_BIN) smc_pnet $(DESTDIR)$(BINDIR)
 	install $(INSTALL_FLAGS_BIN) smc_dbg $(DESTDIR)$(BINDIR)
 ifeq ($(shell uname -m | cut -c1-4),s390)
 	install $(INSTALL_FLAGS_BIN) smc_rnics $(DESTDIR)$(BINDIR)
+	install $(INSTALL_FLAGS_MAN) smc_rnics.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_BIN) smc_chk $(DESTDIR)$(BINDIR)
 endif
 	install $(INSTALL_FLAGS_MAN) af_smc.7 $(DESTDIR)$(MANDIR)/man7
+	install $(INSTALL_FLAGS_MAN) smc_chk.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smc_run.8 $(DESTDIR)$(MANDIR)/man8
-	install $(INSTALL_FLAGS_MAN) smc_rnics.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smc_pnet.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smcss.8 $(DESTDIR)$(MANDIR)/man8
-
+	install $(INSTALL_FLAGS_MAN) smcd.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcr.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-linkgroup.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-device.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-info.8 $(DESTDIR)$(MANDIR)/man8
+	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-linkgroup.8 $(DESTDIR)$(MANDIR)/man8/smcr-linkgroup.8
+	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-device.8 $(DESTDIR)$(MANDIR)/man8/smcr-device.8
+	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-info.8 $(DESTDIR)$(MANDIR)/man8/smcr-info.8
+ifneq ($(BASH_AUTODIR),)
+	install $(INSTALL_FLAGS_MAN) smc-tools.autocomplete $(DESTDIR)$(BASH_AUTODIR)/smc-tools
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc_rnics
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc_chk
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc_dbg
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smcss
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc_pnet
+	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc
+endif
+
+check:
+	if which cppcheck >/dev/null; then \
+	    echo "Running cppcheck"; \
+	    cppcheck . 2>&1; \
+	else \
+	    echo "cppcheck not available"; \
+	fi
+	@echo;
+	if which valgrind >/dev/null; then \
+	    echo "Running valgrind"; \
+	    valgrind --leak-check=full --show-leak-kinds=all ./smcss 2>&1; \
+	    valgrind --leak-check=full --show-leak-kinds=all ./smc_pnet 2>&1; \
+	    valgrind --leak-check=full --show-leak-kinds=all ./smc 2>&1; \
+	else \
+	    echo "valgrind not available"; \
+	fi
+	@echo;
 clean:
 	echo "  CLEAN"
-	rm -f *.o *.so smcss smc_pnet
+	rm -f *.o *.so *.a smc smcd smcr smcss smc_pnet

=== debian/changelog ===
smc-tools (1.5.0-0ubuntu2) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 17:06:01 +0000

smc-tools (1.5.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release. LP: #1914034
  * Add watch file.
  * Drop multiarch patch, applied upstream.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 11 Feb 2021 15:51:30 +0000

## smc-tools 1.6.0

=== debian/changelog ===
smc-tools (1.6.0-0ubuntu1) impish; urgency=medium

  * New upstream release. LP: #1853301
  * Add cherry-picked patches from upstream
    - smc-tools: stats: Fix memory overread in is_data_consistent()
      011fc850e4e7a272896ea53cf178ff39972ff74d.patch
    - smc-tools: stats: Fix memory and file handle leaks
      3c47b5b90bf931714ee079bed7d74c6104bff784.patch
    - smc-tools: stats: Use correct fallback counter values after reset
      f6d8435b8895218d00d1ec8426af3995d6dd58da.patch

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 12 Aug 2021 16:16:34 -0500

## smc-tools 1.7.0

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.5.0
+SMC_TOOLS_RELEASE = 1.7.0
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)
@@ -61,16 +61,16 @@
 all: libsmc-preload.so libsmc-preload32.so smcd smcr smcss smc_pnet
 
 CFLAGS ?= -Wall -O3 -g
-ALL_CFLAGS = -DSMC_TOOLS_RELEASE=$(SMC_TOOLS_RELEASE) $(CFLAGS)
-
 ifneq ($(shell sh -c 'command -v pkg-config'),)
-SMC_PNET_CFLAGS = $(shell pkg-config --silence-errors --cflags libnl-genl-3.0)
-SMC_PNET_LFLAGS = $(shell pkg-config --silence-errors --libs libnl-genl-3.0)
-else
-SMC_PNET_CFLAGS = -I /usr/include/libnl3
-SMC_PNET_LFLAGS = -lnl-genl-3 -lnl-3
-endif
-CFLAGS += ${SMC_PNET_CFLAGS}
+LIBNL_CFLAGS = $(shell pkg-config --silence-errors --cflags libnl-genl-3.0)
+LIBNL_LFLAGS = $(shell pkg-config --silence-errors --libs libnl-genl-3.0)
+else
+LIBNL_CFLAGS = -I /usr/include/libnl3
+LIBNL_LFLAGS = -lnl-genl-3 -lnl-3
+endif
+ALL_CFLAGS += ${CFLAGS} -DSMC_TOOLS_RELEASE=$(SMC_TOOLS_RELEASE) \
+              ${LIBNL_CFLAGS} ${OPTFLAGS}
+ALL_LDFLAGS += ${LDFLAGS} ${LIBNL_LFLAGS} -lm
 
 ifeq ($(ARCHTYPE),s390x)
 	MACHINE_OPT32="-m31"
@@ -79,23 +79,23 @@
 endif
 
 util.o: util.c  util.h
-	${CCC} ${CFLAGS} -c util.c
+	${CCC} ${ALL_CFLAGS} -c util.c
 
 libnetlink.o: libnetlink.c  libnetlink.h
-	${CCC} ${CFLAGS} ${LDFLAGS} -c libnetlink.c
+	${CCC} ${ALL_CFLAGS} ${ALL_LDFLAGS} -c libnetlink.c
 
 smc-preload.o: smc-preload.c
-	${CCC} ${CFLAGS} -fPIC -c smc-preload.c
+	${CCC} ${ALL_CFLAGS} -fPIC -c smc-preload.c
 
 libsmc-preload.so: smc-preload.o
-	${LINK} ${LDFLAGS} -shared smc-preload.o -ldl -Wl,-z,defs,-soname,$@.$(VER_MAJOR) -o $@
+	${LINK} ${ALL_LDFLAGS} -shared smc-preload.o -ldl -Wl,-z,defs,-soname,$@.$(VER_MAJOR) -o $@
 	chmod u+s $@
 
 libsmc-preload32.so: smc-preload.c
 ifeq ($(ARCH),64)
 ifeq ($(STUFF_32BIT),1)
-	${CCC} ${CFLAGS} -fPIC -c ${MACHINE_OPT32} $< -o smc-preload32.o
-	${LINK} ${LDFLAGS} -shared smc-preload32.o ${MACHINE_OPT32} -ldl -Wl,-soname,$@.$(VER_MAJOR) -o $@
+	${CCC} ${ALL_CFLAGS} -fPIC -c ${MACHINE_OPT32} $< -o smc-preload32.o
+	${LINK} ${ALL_LDFLAGS} -shared smc-preload32.o ${MACHINE_OPT32} -ldl -Wl,-soname,$@.$(VER_MAJOR) -o $@
 	chmod u+s $@
 else
 	$(warning "Warning: Skipping 31/32-bit library build because 31/32-bit build tools")
@@ -115,14 +115,14 @@
 %.o: %.c
 	${CCC} ${ALL_CFLAGS} -c $< -o $@
 
-smc: smc.o dev.o linkgroup.o libnetlink.o util.o
-	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
-
-smcd: smcd.o infod.o devd.o linkgroupd.o libnetlink.o util.o
-	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
-
-smcr: smcr.o infor.o devr.o linkgroupr.o libnetlink.o util.o
-	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
+smc: smc.o info.o ueid.o seid.o dev.o linkgroup.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} ${ALL_LDFLAGS} $^ -o $@
+
+smcd: smcd.o infod.o ueidd.o seidd.o devd.o linkgroupd.o statsd.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} $^ ${ALL_LDFLAGS} -o $@
+
+smcr: smcr.o infor.o ueidr.o seidr.o devr.o linkgroupr.o statsr.o libnetlink.o util.o
+	${CCC} ${ALL_CFLAGS} $^ ${ALL_LDFLAGS} -o $@
 
 smc_pnet: smc_pnet.c smctools_common.h
 	@if [ ! -e /usr/include/libnl3/netlink/netlink.h ]; then \
@@ -135,12 +135,10 @@
 		printf "**************************************************************\n" >&2; \
 		exit 1; \
 	fi
-	${CCC} ${ALL_CFLAGS} ${SMC_PNET_CFLAGS} ${LDFLAGS} -o $@ $< ${SMC_PNET_LFLAGS}
+	${CCC} ${ALL_CFLAGS} $< ${ALL_LDFLAGS} -o $@
 
 smcss: smcss.o libnetlink.o
-	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $^ ${SMC_PNET_LFLAGS} -o $@
-#smcss: smcss.c smctools_common.h libnetlink.h
-#	${CCC} ${ALL_CFLAGS} ${LDFLAGS} $< -o $@
+	${CCC} ${ALL_CFLAGS} $^ ${ALL_LDFLAGS} -o $@
 
 install: all
 	echo "  INSTALL"
@@ -161,9 +159,9 @@
 	install $(INSTALL_FLAGS_BIN) smc_rnics $(DESTDIR)$(BINDIR)
 	install $(INSTALL_FLAGS_MAN) smc_rnics.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_BIN) smc_chk $(DESTDIR)$(BINDIR)
+	install $(INSTALL_FLAGS_MAN) smc_chk.8 $(DESTDIR)$(MANDIR)/man8
 endif
 	install $(INSTALL_FLAGS_MAN) af_smc.7 $(DESTDIR)$(MANDIR)/man7
-	install $(INSTALL_FLAGS_MAN) smc_chk.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smc_run.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smc_pnet.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smcss.8 $(DESTDIR)$(MANDIR)/man8
@@ -172,9 +170,14 @@
 	install $(INSTALL_FLAGS_MAN) smcd-linkgroup.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smcd-device.8 $(DESTDIR)$(MANDIR)/man8
 	install $(INSTALL_FLAGS_MAN) smcd-info.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-stats.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-ueid.8 $(DESTDIR)$(MANDIR)/man8
+	install $(INSTALL_FLAGS_MAN) smcd-seid.8 $(DESTDIR)$(MANDIR)/man8
 	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-linkgroup.8 $(DESTDIR)$(MANDIR)/man8/smcr-linkgroup.8
 	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-device.8 $(DESTDIR)$(MANDIR)/man8/smcr-device.8
 	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-info.8 $(DESTDIR)$(MANDIR)/man8/smcr-info.8
+	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-stats.8 $(DESTDIR)$(MANDIR)/man8/smcr-stats.8
+	ln -sfr $(DESTDIR)$(MANDIR)/man8/smcd-ueid.8 $(DESTDIR)$(MANDIR)/man8/smcr-ueid.8
 ifneq ($(BASH_AUTODIR),)
 	install $(INSTALL_FLAGS_MAN) smc-tools.autocomplete $(DESTDIR)$(BASH_AUTODIR)/smc-tools
 	ln -sfr $(DESTDIR)$(BASH_AUTODIR)/smc-tools $(DESTDIR)$(BASH_AUTODIR)/smc_rnics

=== debian/changelog ===
smc-tools (1.7.0-0ubuntu1) jammy; urgency=medium

  * New upstream release. LP: #1959428
  * All existing quilt patches could be removed,
    since they are all incl. in v1.7.0.

 -- Frank Heimes <frank.heimes@canonical.com>  Sun, 30 Jan 2022 17:04:06 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: optional
 Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
-Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion
+Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion, pkg-config
 Standards-Version: 4.2.1
 Homepage: https://www.ibm.com/developerworks/linux/linux390/smc-tools.html

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%smc-tools-$1.tar.gz%" \
     https://github.com/ibm-s390-tools/smc-tools/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## smc-tools 1.8.2

=== debian/changelog ===
smc-tools (1.8.2-0ubuntu1) lunar; urgency=medium

  * New upstream release. LP: #1999729
  * Update Standards-Version to current 4.6.1.0 in d/control.
  * Update Homepage URL in d/control.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 15 Dec 2022 10:22:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
 Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion, pkg-config
-Standards-Version: 4.2.1
-Homepage: https://www.ibm.com/developerworks/linux/linux390/smc-tools.html
+Standards-Version: 4.6.1.0
+Homepage: https://github.com/ibm-s390-linux/smc-tools
 
 Package: smc-tools
 Architecture: any

## smc-tools 1.8.3

=== debian/changelog ===
smc-tools (1.8.3-0ubuntu1) mantic; urgency=medium

  * New upstream release. LP: #2027825
  * Remove d/p/adjust-default-library-path-for-ubuntu.patch.
  * Add d/p/fix_library_path.patch to avoid having /usr twice in path.

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 09 Aug 2023 12:06:37 +0200

smc-tools (1.8.2-0ubuntu3) lunar; urgency=medium

  * Remove debian/links again, due to comment on the LP bug.
  * Add d/p/adjust-default-library-path-for-ubuntu.patch to change the
    library path for Ubuntu already inside the Makefile.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 21 Mar 2023 12:30:55 +0100

smc-tools (1.8.2-0ubuntu2) lunar; urgency=medium

  * Add lsb-release as Build-Depends to debian/control, since it's not
    installed by default in all build environments, but the lsb_release
    command is used in the Makefile. If it's not there the Makefile defaults
    to the the wrong folder /usr/lib64 for Ubuntu. LP: #2009495
  * Add debian/links file to ensure that libsmc-preload.so is also
    accessible from /usr/lib (and not only from /usr/lib/s390x-linux-gnu).

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 08 Mar 2023 18:58:21 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: optional
 Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
-Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion, pkg-config
+Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion, pkg-config, lsb-release
 Standards-Version: 4.6.1.0
 Homepage: https://github.com/ibm-s390-linux/smc-tools

## smc-tools 1.8.4

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.7.0
+SMC_TOOLS_RELEASE = 1.8.4
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)
@@ -42,7 +42,7 @@
 #
 ifeq ($(ARCH),64)
 ifeq ($(DISTRO),Ubuntu)
-LIBDIR		= ${PREFIX}/lib/${ARCHTYPE}-linux-gnu
+LIBDIR		= ${PREFIX}/usr/lib
 else
 LIBDIR		= ${PREFIX}/lib64
 endif
@@ -106,13 +106,13 @@
 endif
 
 
-%d.o: %.c
+%d.o: %.c smctools_common.h
 	${CCC} ${ALL_CFLAGS} -DSMCD -c $< -o $@
 
-%r.o: %.c
+%r.o: %.c smctools_common.h
 	${CCC} ${ALL_CFLAGS} -DSMCR -c $< -o $@
 
-%.o: %.c
+%.o: %.c smctools_common.h
 	${CCC} ${ALL_CFLAGS} -c $< -o $@
 
 smc: smc.o info.o ueid.o seid.o dev.o linkgroup.o libnetlink.o util.o
@@ -189,18 +189,20 @@
 endif
 
 check:
-	if which cppcheck >/dev/null; then \
+	if ( command -v cppcheck >/dev/null ); then \
 	    echo "Running cppcheck"; \
 	    cppcheck . 2>&1; \
 	else \
 	    echo "cppcheck not available"; \
 	fi
 	@echo;
-	if which valgrind >/dev/null; then \
+	#if type -p valgrind >/dev/null; then \
+	if ( command -v valgrind >/dev/null ); then \
 	    echo "Running valgrind"; \
 	    valgrind --leak-check=full --show-leak-kinds=all ./smcss 2>&1; \
 	    valgrind --leak-check=full --show-leak-kinds=all ./smc_pnet 2>&1; \
-	    valgrind --leak-check=full --show-leak-kinds=all ./smc 2>&1; \
+	    valgrind --leak-check=full --show-leak-kinds=all ./smcd info 2>&1; \
+	    valgrind --leak-check=full --show-leak-kinds=all ./smcd stats 2>&1; \
 	else \
 	    echo "valgrind not available"; \
 	fi

=== debian/changelog ===
smc-tools (1.8.4-0ubuntu1) plucky; urgency=medium

  * New upstream release. LP: #2095005
  * Modify d/control:
    - to replace obsolete pkg-config in Build-Depends by pkgconf
    - to bump debhelper-compat in Build-Depends to level 13
    - to bump Standards-Version to 4.7.0
  * Check for DEP-17 compliance (/usr-merge) and it is, nothing to do.

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 15 Jan 2025 12:11:16 +0100

## smc-tools 1.8.5

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.8.4
+SMC_TOOLS_RELEASE = 1.8.5
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)

=== debian/changelog ===
smc-tools (1.8.5-0ubuntu1) questing; urgency=medium

  * New upstream release. LP: #2119285

 -- Frank Heimes <frank.heimes@canonical.com>  Fri, 01 Aug 2025 11:14:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,12 @@
 Section: net
 Priority: optional
 Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
-Build-Depends: debhelper-compat (= 12), libnl-genl-3-dev, bash-completion, pkg-config, lsb-release
-Standards-Version: 4.6.1.0
+Build-Depends: bash-completion,
+ debhelper-compat (= 13),
+ libnl-genl-3-dev,
+ lsb-release,
+ pkgconf,
+Standards-Version: 4.7.0
 Homepage: https://github.com/ibm-s390-linux/smc-tools
 
 Package: smc-tools

## smc-tools 1.8.6

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.8.5
+SMC_TOOLS_RELEASE = 1.8.6
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)

=== debian/changelog ===
smc-tools (1.8.6-0ubuntu1) resolute; urgency=medium

  * New upstream version 1.8.6 (LP: #2138644).
    - d/watch: update to version 5 to address lintian tag
      older-debian-watch-file-standard
    - d/control: update standards version to latest 4.7.2 to address lintian
      tag out-of-date-standards-version
    - d/p/fix_library_path.patch: add Forwarded field to address lintian tag
      patch-not-forwarded-upstream; Forwarded field set to 'not-needed' since
      this patch is Ubuntu specific
    - d/p/fix_typo_in_manual_page.patch: fix typos to address
      lintian tag typo-in-manual-page
    - d/p/fix_folder_31_32_bit_systems.patch: fix folder in case package
      is for a 32-bit system other than s390, like armhf

 -- Ishraq Islam <ishraq.islam@canonical.com>  Thu, 22 Jan 2026 21:54:55 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  libnl-genl-3-dev,
  lsb-release,
  pkgconf,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ibm-s390-linux/smc-tools
 
 Package: smc-tools

=== debian/watch ===
Version: 5

Template: Github
Owner: ibm-s390-tools
Project: smc-tools
Update-Script: uupdate

## smc-tools 1.8.7

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # http://www.eclipse.org/legal/epl-v10.html
 #
 
-SMC_TOOLS_RELEASE = 1.8.6
+SMC_TOOLS_RELEASE = 1.8.7
 VER_MAJOR         = $(shell echo $(SMC_TOOLS_RELEASE) | cut -d '.' -f 1)
 
 ARCHTYPE = $(shell uname -m)

=== debian/changelog ===
smc-tools (1.8.7-0ubuntu1) resolute; urgency=medium

  * New upstream release 1.8.7 (LP: #2142098).
    - Update Maintainer field in d/control to Ubuntu Developers.

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 18 Feb 2026 09:05:46 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: smc-tools
 Section: net
 Priority: optional
-Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: bash-completion,
  debhelper-compat (= 13),
  libnl-genl-3-dev,
